
-- #######################################
-- #######################################
--              UNIT AURA
-- #######################################
-- #######################################
function GoH.events.UNIT_AURA(name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable)

	-- ################################################################

	-- DEBUGGER
	if GoHv5_DeathKnight_Data.config.DEBUG_UNIT_AURA == "YES" then
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~ BEGIN DEBUG ~~~~~~~~~~~");
			print("~          (UNIT_AURA)          ~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
			if name ~= nil then print("name: "..name) end;
			if rank ~= nil then print("rank: "..rank) end;
			if icon ~= nil then print("icon: "..icon) end;
			if count ~= nil then print("count: "..count) end;
			if debuffType ~= nil then print("debuffType: "..debuffType) end;
			if duration ~= nil then print("duration: "..duration) end;
			if expirationTime ~= nil then print("expirationTime: "..expirationTime) end;
			if unitCaster ~= nil then print("unitCaster: "..unitCaster) end;
			if isStealable ~= nil then print("isStealable: "..isStealable) end;
			print("");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("~~~~~~~~~~~~ END DEBUG ~~~~~~~~~~~~");
			print("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
			print("");
	end

	-- ################################################################

end

-- #######################################
-- #######################################
-- COMBAT LOG EVENT UNFILTERED
-- #######################################
-- #######################################
function GoH.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)

  -- ###########################################################################################################
  -- SINCE THESE ARE LOCAL, YOU CAN RE-USE THE SAME NAMES IN OTHER GOH CLASS MODS AND DON'T HAVE TO CHANGE THEM.
  -- ###########################################################################################################
  local GoH_spellID, GoH_spellName, GoH_all_spellSchool, GoH_amount, GoH_overkill, GoH_school, GoH_resisted, GoH_blocked, GoH_absorbed, GoH_critical, GoH_glancing, GoH_crushing = ...

	-- ################################################################
	-- CHECK THE TIMER
	if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == nil then
		GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "YES";
	end
	-- ################################################################

		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- #####        BEGIN INTERRUPT MOD          #####
	      -- ###############################################
	      -- ###############################################

			local GoH_INT_numParty	= GetNumGroupMembers();

			if GoHv5_DeathKnight_Data.config.Interrupt_Announcements_Enabled == "YES" then -- BEGIN ENABLE INTERRUPT MOD CHECK

				if ((event == "SPELL_INTERRUPT")) and (sourceName == UnitName("player")) then -- BEGIN PLAYER AND EVENT CHECK

					local GoH_INT_Channel = GoHv5_DeathKnight_Data.config.Interrupt_Announcement_Channel;
					local GoH_intmsg = ("Interrupted");

					-- INTERRUPT MESSAGE
					GoH_intmsg = ("Interrupted");

					-- INTERRUPT MESSAGE PLUS TARGET
	  				if GoHv5_DeathKnight_Data.config.Interrupt_Announcement_TARGET == "YES" then
						GoH_intmsg = (GoH_intmsg.." "..destName)
					end

					-- INCLUDE SPELL (GoH_amount becomes skillID for interrupts)
					if GoHv5_DeathKnight_Data.config.Interrupt_Announcement_SPELL == "YES" then
						if GoHv5_DeathKnight_Data.config.Interrupt_Announcement_TARGET == "YES" then
							GoH_intmsg = (GoH_intmsg.."'s "..GetSpellLink(GoH_amount))
						else
							GoH_intmsg = (GoH_intmsg.." "..GetSpellLink(GoH_amount))
						end
					end

					-- INTERRUPT MESSAGE PARTY / RAID (RAID AND PARTY IS SEPARATE FROM THE OTHER OPTIONS)
					if ((UnitInRaid("player")) and (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_RAID == "YES")) then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							SendChatMessage(GoH_intmsg, "RAID")

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					elseif ((UnitInParty("player")) and (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_PARTY == "YES") and (GoH_INT_numParty > 0)) then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							SendChatMessage(GoH_intmsg, "PARTY")

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					end

					-- INTERRUPT MESSAGE YELL (WILL ONLY BE YELL SAY OR EMOTE)
					if (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_YELL == "YES") then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							SendChatMessage(GoH_intmsg, GoH_INT_Channel);

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					end
					-- INTERRUPT MESSAGE SAY (WILL ONLY BE YELL SAY OR EMOTE)
					if (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_SAY == "YES") then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							SendChatMessage(GoH_intmsg, GoH_INT_Channel);

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					end
					-- INTERRUPT MESSAGE EMOTE (WILL ONLY BE YELL SAY OR EMOTE)
					if (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_EMOTE == "YES") then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							SendChatMessage(GoH_intmsg, GoH_INT_Channel);

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					end

					-- INTERRUPT MESSAGE SELF (CAN BE PLAYED ALONG WITH ONE OF THE ABOVE THREE CHANNELS, YELL SAY OR EMOTE)
					if (GoHv5_DeathKnight_Data.config.Interrupt_Announcement_SELF == "YES") then

						-- SECONDARY TIMER
						if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

							print(GoH_intmsg);

							-- RESET THE SECONDARY TIMER
							GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
							-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

						end

					end

					-- ESSENTIALLY YOU CAN HAVE IT ANNOUNCE IN THREE DIFFERENT PLACES:
					-- - RAID / PARTY
					-- - YELL / SAY / EMOTE
					-- - SELF

					-- PLAY INTERRUPTED SOUND AND SHOW INTERRUPTED SCREEN
					Show_Interrupted_Frame();

				end -- END PLAYER AND EVENT CHECK

			end -- END ENABLE INTERRUPT MOD CHECK

	      -- ###############################################
	      -- ###############################################
	      -- #####          END INTERRUPT MOD          #####
	      -- ###############################################
	      -- ###############################################

		-- #######################################

		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- #####        BEGIN CRITICAL HIT MOD       #####
	      -- ###############################################
	      -- ###############################################

	  	if GoHv5_DeathKnight_Data.config.Use_Critical_Hits == "YES" then
			if (sourceName ~= nil) and (sourceName == GoH_DeathKnight.CharName) and (GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES") then -- BEGIN PLAYER SOURCENAME CHECK

				if( GoH_critical ) and ((event == "SPELL_DAMAGE") or (event == "SPELL_PERIODIC_DAMAGE")) then

					-- CRITICAL SPELL_DAMAGE OR SPELL_PERIODIC_DAMAGE
					-- SECONDARY TIMER
					if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

						GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits = (GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits + 1);

						-- RESET THE SECONDARY TIMER
						GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
					-- print(GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits);

					Show_Critical_Hit_Frame();
					Play_Critical_Hit_Random_Sound();
					-- print("Critical Spell Damage");

				-- BECAUSE I AM SHARING THE VARIABLES ABOVE, THE FOLLOWING CHANGES OCCUR FOR THE SWING_DAMAGE EVENT
				-- GoH_critical becomes GoH_blocked

				elseif ( GoH_blocked ) and (event == "SWING_DAMAGE") then

					-- CRITICAL SWING_DAMAGE
					-- SECONDARY TIMER
					if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

						GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits = (GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits + 1);

						-- RESET THE SECONDARY TIMER
						GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
					-- print(GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits);

					Show_Critical_Hit_Frame();
					Play_Critical_Hit_Random_Sound();
					-- print("Critical Swing Damage");

				else
					-- NOT CRITICAL
				end

			end -- END PLAYER SOURCENAME CHECK
		end

	      -- ###############################################
	      -- ###############################################
	      -- #####        END CRITICAL HIT MOD         #####
	      -- ###############################################
	      -- ###############################################

		-- #######################################
		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- #####     BEGIN FINISH IT/HER/HIM MOD     #####
	      -- ###############################################
	      -- ###############################################

	if (sourceName == GoH_DeathKnight.CharName) then -- BEGIN PLAYER SOURCENAME CHECK

		if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Sounds == "YES" then -- BEGIN OPTION CHECK

	      -- ###############################################
	      -- ###############################################

			if (event == "SWING_DAMAGE") or (event == "SPELL_DAMAGE") or (event == "SPELL_PERIODIC_DAMAGE") then -- BEGIN EVENT CHECK SPELL DAMAGE
				if (UnitName("target") ~= nil) then -- BEGIN TARGET NOT NIL CHECK
					if UnitIsDeadOrGhost("target") then -- BEGIN TARGET NOT DEAD CHECK
						-- IF YOUR TARGET IS DEAD OR A GHOST DO NOTHING.
					else -- ELSE TARGET NOT DEAD CHECK
						-- YOUR TARGET MUST STILL BE ALIVE AND NOT A GHOST. and (GoH_overkill < 1)
						if UnitHealth("target") ~= nil then -- BEGIN TARGETHEALTH NIL CHECK
						if ((UnitHealth("target") / UnitHealthMax("target")) <= 0.20) and (GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced == "NO") then -- BEGIN BOOM CHECK
							if ((UnitHealth("target") / UnitHealthMax("target")) >= 0.01) then -- BEGIN TARGET HEALTH CHECK
								if UnitExists("target") and not UnitIsFriend("player", "target") then -- BEGIN NOT A FRIEND EXISTS CHECK
									-- ###############################################
									if (UnitSex("target") == 1) then -- BEGIN GENDER 'IT' CHECK

										-- PLAY 'IT' SOUND
										Play_Combat_Finish_It();

										-- SHOW 'IT' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_It_Frame();
										end

									end -- END GENDER 'IT' CHECK
									-- ###############################################
									-- ###############################################
									if (UnitSex("target") == 2) then -- BEGIN GENDER 'MALE' CHECK

										-- PLAY 'HIM' SOUND
										Play_Combat_Finish_Him();

										-- SHOW 'HIM' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_Him_Frame();
										end

									end -- END GENDER 'MALE' CHECK
									-- ###############################################
									-- ###############################################
									if (UnitSex("target") == 3) then -- BEGIN GENDER 'FEMALE' CHECK

										-- PLAY 'HER' SOUND
										Play_Combat_Finish_Her();

										-- SHOW 'HER' GRAPHIC IMAGE
										if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Image == "YES" then
											Show_Finish_Her_Frame();
										end

									end -- ENDGENDER 'FEMALE' CHECK
									-- ###############################################
									-- ###############################################
									-- CHANGE THE ANNOUNCEMENT SAVED VARIABLE SO WE DON'T SPAM IT!

									GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced = "YES";

									-- ###############################################
								end -- END NOT A FRIEND EXISTS CHECK
							end -- END TARGET HEALTH CHECK
						end -- END BOOM CHECK
						end -- END TARGETHEALTH NIL CHECK
					end -- END TARGET NOT DEAD CHECK
				end -- END TARGET NOT NIL CHECK
			end -- END EVENT CHECK SPELL DAMAGE

	      -- ###############################################
	      -- ###############################################

		end -- END OPTION CHECK

	end -- END PLAYER SOURCENAME CHECK

	      -- ###############################################
	      -- ###############################################
	      -- #####      END FINISH IT/HER/HIM MOD      #####
	      -- ###############################################
	      -- ###############################################

		-- #######################################
		-- #######################################

	      -- ###############################################
	      -- ###############################################
	      -- ##### BEGIN ANNOUNCING CONJURED ITEMS MOD #####
	      -- ###############################################
	      -- ###############################################

				-- RE-CHECK AND SET VARIABLES IF NOT ALREADY SET
				-- GOH SETTING: ANNOUNCE PORTALS
	  			if GoHv5_DeathKnight_Data.config.Announce_Portals == nil then
					GoHv5_DeathKnight_Data.config.Announce_Portals = "NO";
				end
				-- GOH SETTING: ANNOUNCE CONJURED ITEMS
	  			if GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == nil then
					GoHv5_DeathKnight_Data.config.Announce_Conjured_Items = "NO";
				end
				-- GOH SETTING: CONJURE TEMP SPELL
	  			if GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell == nil then
					GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = "BLANK";
				end

	if (GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == "YES") or (GoHv5_DeathKnight_Data.config.Announce_Portals == "YES") then -- BEGIN ANNOUNCE CONJURED ITEMS AND PORTAL CHECK

		-- MESSAGE TYPE?
		msgType = {}
		msgType["pvp"]="BATTLEGROUND"
		msgType["arena"]="PARTY"
		msgType["party"]="PARTY"
		msgType["raid"]="RAID"

	   if (GetNumPartyMembers ~= nil) and (GetNumRaidMembers ~= nil) then -- BEGIN NIL CHECK
		if (GetNumPartyMembers() >= 1) or (GetNumRaidMembers() >= 1) then -- BEGIN PARTY RAID NUMBER CHECK

			if (UnitInParty(sourceName) or UnitInRaid(sourceName)) then -- END PARTY RAID MEMBER CHECK

				-- BEGIN DETECTING CONJURED ITEMS
				if (event == "SPELL_CAST_SUCCESS") or (event == "SPELL_SUMMON") or (event == "SPELL_CAST_START") then -- BEGIN DETECTING CONJURED ITEMS

					if (GoHv5_DeathKnight_Data.config.Announce_Conjured_Items == "YES") then -- BEGIN ANNOUNCE CONJURED ITEMS ONLY CHECK

							-- #######################################

							-- CONJURED: (Mage) Ritual of Refreshment

							if GoH_spellName == Conjure_Ritual_of_Refreshment_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Refreshment_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Warlock) Ritual of Summoning

							if GoH_spellName == Conjure_Ritual_of_Summoning_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Summoning_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end


							-- #######################################
							-- #######################################

							-- CONJURED: (Warlock) Ritual of Souls

							if GoH_spellName == Conjure_Ritual_of_Souls_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Ritual_of_Souls_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Alchemy) Cauldron of Battle

							if GoH_spellName == Conjure_Cauldron_of_Battle_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Cauldron_of_Battle_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Alchemy) Big Cauldron of Battle

							if GoH_spellName == Conjure_Big_Cauldron_of_Battle_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Big_Cauldron_of_Battle_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Goblin Barbecue Feast

							if GoH_spellName == Conjure_Goblin_Barbecue_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Goblin_Barbecue_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) moll-e (Mail Box)

							if GoH_spellName == Conjure_moll_e_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_moll_e_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Scrapbot

							if GoH_spellName == Conjure_Scrapbot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Scrapbot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Engineer) Field Repair Bot 110G

							if GoH_spellName == Conjure_Field_Repair_Bot_110G_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Field_Repair_Bot_110G_Name
							end

							-- #######################################
							-- #######################################
							-- CONJURED: (Engineer) Jeeves

							if GoH_spellName == Conjure_Jeeves_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Jeeves_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Fish Feast

							if GoH_spellName == Conjure_Fish_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Fish_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Great Feast

							if GoH_spellName == Conjure_Great_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Great_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Broiled Dragon Feast

							if GoH_spellName == Conjure_Broiled_Dragon_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Broiled_Dragon_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (Cook) Seafood Magnifique Feast

							if GoH_spellName == Conjure_Seafood_Magnifique_Feast_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Seafood_Magnifique_Feast_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Pandaren Banquet

							if GoH_spellName == MoP_Pandaren_Banquet_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Pandaren_Banquet_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Pandaren Banquet

							if GoH_spellName == MoP_Great_Pandaren_Banquet_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Pandaren_Banquet_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Grill

							if GoH_spellName == MoP_Banquet_of_the_Grill_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Grill_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Grill

							if GoH_spellName == MoP_Great_Banquet_of_the_Grill_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Grill_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Oven

							if GoH_spellName == MoP_Banquet_of_the_Oven_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Oven_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Oven

							if GoH_spellName == MoP_Great_Banquet_of_the_Oven_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Oven_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Brew

							if GoH_spellName == MoP_Banquet_of_the_Brew_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Brew_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Brew

							if GoH_spellName == MoP_Great_Banquet_of_the_Brew_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Brew_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Pot

							if GoH_spellName == MoP_Banquet_of_the_Pot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Pot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Pot

							if GoH_spellName == MoP_Great_Banquet_of_the_Pot_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Pot_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Steamer

							if GoH_spellName == MoP_Banquet_of_the_Steamer_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Steamer_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Steamer

							if GoH_spellName == MoP_Great_Banquet_of_the_Steamer_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Steamer_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Banquet of the Wok

							if GoH_spellName == MoP_Banquet_of_the_Wok_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Banquet_of_the_Wok_Name
							end

							-- #######################################
							-- #######################################

							-- CONJURED: (MOP) Great Banquet of the Wok

							if GoH_spellName == MoP_Great_Banquet_of_the_Wok_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = MoP_Great_Banquet_of_the_Wok_Name
							end

							-- #######################################
							-- #######################################


					end -- END ANNOUNCE CONJURED ITEMS ONLY CHECK
					if (GoHv5_DeathKnight_Data.config.Announce_Portals == "YES") then -- BEGIN ANNOUNCE PORTAL ONLY CHECK

							-- #######################################
							-- #######################################
							  -- MAGE ANCIENT PORTALS: Dalaran

							if GoH_spellID == Conjure_Mage_Ancient_Portal_Dalaran_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Ancient_Portal_Dalaran_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Dalaran

							if GoH_spellID == Conjure_Mage_Portal_Dalaran_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Dalaran_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Darnassus

							if GoH_spellName == Conjure_Mage_Portal_Darnassus_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Darnassus_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Exodar

							if GoH_spellName == Conjure_Mage_Portal_Exodar_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Exodar_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Ironforge

							if GoH_spellName == Conjure_Mage_Portal_Ironforge_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Ironforge_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Orgrimmar

							if GoH_spellName == Conjure_Mage_Portal_Orgrimmar_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Orgrimmar_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Shattrath

							if GoH_spellID == Conjure_Mage_Portal_Shattrath_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Shattrath_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_Shattrath2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Shattrath2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end


							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Silvermoon

							if GoH_spellName == Conjure_Mage_Portal_Silvermoon_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Silvermoon_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Stonard

							if GoH_spellName == Conjure_Mage_Portal_Stonard_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Stonard_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Stormwind

							if GoH_spellName == Conjure_Mage_Portal_Stormwind_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Stormwind_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Theramore

							if GoH_spellName == Conjure_Mage_Portal_Theramore_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Theramore_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Thunderbluff

							if GoH_spellName == Conjure_Mage_Portal_Thunderbluff_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Thunderbluff_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: TolBarad

							if GoH_spellID == Conjure_Mage_Portal_TolBarad_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_TolBarad_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_TolBarad2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_TolBarad2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Undercity

							if GoH_spellName == Conjure_Mage_Portal_Undercity_Name then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Undercity_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							  -- MAGE PORTALS: Vale of Eternal_Blossoms

							if GoH_spellID == Conjure_Mage_Portal_Vale_of_Eternal_Blossoms_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Vale_of_Eternal_Blossoms_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							if GoH_spellID == Conjure_Mage_Portal_Vale_of_Eternal_Blossoms2_ID then
							-- SEND SPELL TO LOCAL VARIABLE
							GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell = Conjure_Mage_Portal_Vale_of_Eternal_Blossoms2_Name
							PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");
							end

							-- #######################################
							-- #######################################
							-- #######################################

					end

					-- #######################################
					-- #######################################
					  -- MAIN ANNOUNCER CODE BELOW
					-- #######################################
					-- #######################################

					if GoH_spellName == GoHv5_DeathKnight_Data.config.Conjure_Temp_Spell then -- BEGIN CHECK SPELL DETECTED

							Play_Conjure_Murloc();

							inInstance, instanceType = IsInInstance()

							-- DUNGEON? RAID?
							if inInstance == 1 and instanceType ~= "none" then
								messageType = msgType[instanceType]
							end

							-- CAN DO RAID WARNINGS? IF SO - DO IT
							if (IsRaidOfficer()==1 and instanceType=="raid") then
								messageType = "RAID_WARNING"
							end
							if (UnitIsGroupAssistant("player") or UnitIsGroupLeader("player")) then
								messageType = "RAID_WARNING"
							end


							-- CAULDRONS SEEM TO ONLY HAVE NOTHING IN 'destName'
							-- SO WE WILL COPY FROM 'spellName'
							-- CAULDRONS ONLY SHOW UP IN 'SPELL_CAST_START'
							if (destName==nil) then
								destName = GoH_spellName
							end

							if (messageType==nil) then -- BEGIN MESSAGE TYPE CHECK

								-- #######################################
								-- #######################################

									-- SPAM TIMER CHECK
									if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then -- BEGIN SPAM CHECK

									-- IF NOT IN A DUNGEON OR RAID INSTANCE ((OUTSIDE)) THEN USE YOUR OWN TICK OPTIONS
									-- HAVEN'T INCLUDED THIS YET...

										-- SOLO ANNOUNCEMENT MAYBE...

										-- RESET THE TIMER
										GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
										-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

									end -- END SPAM CHECK

								-- #######################################
								-- #######################################

							else -- ELSE MESSAGE TYPE CHECK
								-- YOU'RE NOT SOLO

								-- #######################################
								-- #######################################

									-- SPAM TIMER CHECK
									if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then -- BEGIN SPAM CHECK

									-- IF NOT IN A DUNGEON OR RAID INSTANCE ((OUTSIDE)) THEN USE YOUR OWN TICK OPTIONS
									-- HAVEN'T INCLUDED THIS YET...

											-- IF IN A DUNGEON OR RAID INSTANCE ((INSIDE)) THEN USE WHAT IS RETURNED
											AnnouncingMsg = ("{star} " .. sourceName .. " creates " .. destName .." {star}");


											-- SEND THE CHAT MESSAGE
											SendChatMessage(AnnouncingMsg, messageType)


										-- RESET THE TIMER
										GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
										-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

									end -- END SPAM CHECK

								-- #######################################
								-- #######################################

							end -- END MESSAGE TYPE CHECK

					end -- END CHECK SPELL DETECTED

					-- #######################################
					-- #######################################

				end -- END DETECTING CONJURED ITEMS

			end -- END PARTY RAID MEMBER CHECK

		end -- END PARTY RAID NUMBER CHECK
	   end -- END NIL CHECK

	end  -- END ANNOUNCE CONJURED ITEMS AND PORTAL CHECK

		-- #######################################
		-- #######################################

end



-- #######################################
-- #######################################
-- PLAYER ENTER COMBAT
-- #######################################
-- #######################################
function GoH.events.PLAYER_REGEN_DISABLED()

		-- #######################################

		if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

			GoH_DND_Combat_Mode_On();

			-- RESET THE TIMER
			GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
			-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

		end

		-- #######################################

		if GoHv5_DeathKnight_Data.config.Use_Fight_Image == nil then
			GoHv5_DeathKnight_Data.config.Use_Fight_Image = "YES";
		end
		if GoHv5_DeathKnight_Data.config.Use_Fight_Image == "YES" then

			Show_Fight_Frame();

		end

end



-- #######################################
-- #######################################
-- PLAYER LEAVE COMBAT
-- #######################################
-- #######################################
function GoH.events.PLAYER_REGEN_ENABLED()

		-- #######################################

		if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

			GoH_DND_Combat_Mode_Off();

			-- RESET THE TIMER
			GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
			-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

		end

		-- #######################################

		-- RESET CRITICAL HIT COUNTER
		GoHv5_DeathKnight_Data.config.COUNTER_Critical_Hits = 0;
		-- RESET KILLING BLOW COUNTER
		GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows = 0;

end



-- #######################################
-- #######################################
-- UNIT COMBAT
-- #######################################
-- #######################################
function GoH.events.UNIT_COMBAT(arg1, arg2)

		-- #######################################

			-- BLOCK EVENT
			if (arg1=="player") and (arg2=="BLOCK") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Block == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Block == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Block.mp3","Master");
				end
			end

			-- DODGE EVENT
			if (arg1=="player") and (arg2=="DODGE") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Dodge == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Dodge == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Dodge.mp3","Master");
				end
			end

			-- MISS EVENT
			if (arg1=="player") and (arg2=="MISS") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Miss == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Miss == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Miss.mp3","Master");
				end
			end

			-- PARRY EVENT
			if (arg1=="player") and (arg2=="PARRY") then
				if GoHv5_DeathKnight_Data.config.Combat_Text_Parry == "YES" then
					UIErrorsFrame:AddMessage("|cFFFFD000" .. arg2 .. "|r");
				end
				if GoHv5_DeathKnight_Data.config.Combat_Sound_Parry == "YES" then
					PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Parry.mp3","Master");
				end
			end


		-- #######################################
end


function GoH.events.PLAYER_TARGET_CHANGED()

	GoHv5_DeathKnight_Data.config.ALERTED_ABOUT_A_RARE = "NO";

	local GoH_Target_Name, _ = UnitName("target")

	-- IF WE ARE USING THE 'FINISH HIM' OPTION, WE NEED TO RESET THE ANNOUNCEMENT ON TARGET CHANGE
	if GoHv5_DeathKnight_Data.config.Use_Finish_Him_Sounds == "YES" then

		-- WE HAVE A NEW TARGET SO RESET THE 'FINISH HIM' ANNOUNCEMENT SAVED VARIABLE
		GoHv5_DeathKnight_Data.config.Finish_It_Has_Been_Announced = "NO";

	end

	-- PLAY SOUND ON TARGET CLICK
	if GoHv5_DeathKnight_Data.config.Use_Target_Sounds == "YES" then

		if (UnitName("target") ~= nil) and (GoH_Target_Name ~= nil) then
		GoHv5_DeathKnight_Data.config.Temp_Target_Name = GoH_Target_Name
		-- print(GoHv5_DeathKnight_Data.config.Temp_Target_Name);
			if (UnitHealth("target") ~= 0) then
				-- TARGET IS ALIVE
				-- Thanks to Shao_Kahn_FTW for this idea
				Play_Random_Alive_Target();
			else
				-- TARGET IS DEAD
				Play_Random_Dead_Target();
			end
		else
		-- PLAY NOTHING IF NO TARGET
		end

	end

end

-- #######################################
-- #######################################
-- PLAYER ENTERING BATTLEGROUND
-- #######################################
-- #######################################
function GoH.events.PLAYER_ENTERING_BATTLEGROUND()

		-- #######################################

		if GoHv5_DeathKnight_Data.config.Play_BattleGround_Sounds == "YES" then

			Play_Random_BattleGround_Sound();

		end

		-- #######################################

end


-- #######################################
-- #######################################
-- UNIT TARGET EVENT
-- #######################################
-- #######################################
function GoH.events.UNIT_TARGET(arg1)


	-- #######################################
	--  RARE ANNOUNCER
	-- #######################################
	local GoH_Classification = UnitClassification("target");
	-- print(GoH_Classification);
	-- "worldboss", "rareelite", "elite", "rare", "normal", "trivial" or "minus"

	if GoH_Classification == "rare" then

		if (GoHv5_DeathKnight_Data.config.ALERTED_ABOUT_A_RARE == "NO") and UnitExists("target") and not UnitIsDeadOrGhost("target") then
			PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Rare_Alert.mp3","Master");
			PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Rare_Alert.mp3","Master");
			GoHv5_DeathKnight_Data.config.ALERTED_ABOUT_A_RARE = "YES";
			UIErrorsFrame:AddMessage("Rare!");
		end

	elseif GoH_Classification == "rareelite" then

		if (GoHv5_DeathKnight_Data.config.ALERTED_ABOUT_A_RARE == "NO") and UnitExists("target") and not UnitIsDeadOrGhost("target") then
			PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Rare_Alert.mp3","Master");
			PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Rare_Alert.mp3","Master");
			GoHv5_DeathKnight_Data.config.ALERTED_ABOUT_A_RARE = "YES";
			UIErrorsFrame:AddMessage("Rare Elite!");
		end

	end
	-- #######################################


		local guid = UnitGUID("target");
		if guid ~= nil then
			local B = tonumber(guid:sub(5,5), 16);
			local maskedB = B % 8; -- x % 8 has the same effect as x & 0x7 on numbers <= 0xf
			local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
			GoHv5_DeathKnight_Data.config.KnownTypes = (knownTypes[maskedB] or " unknown entity!");
			-- print("Your target is a " .. GoHv5_DeathKnight_Data.config.KnownTypes);
		end

	-- arg1 = player (was just testing it)
	-- print(arg1);

	GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level_TEMP = UnitLevel("target");

		-- #######################################

				-- GOH SETTING: YOUR TARGET IS A
	  			if GoHv5_DeathKnight_Data.config.Your_Target_Is_A == nil then
					GoHv5_DeathKnight_Data.config.Your_Target_Is_A = "No Target";
				end

		if (UnitCreatureType("target") ~= nil) and (GoHv5_DeathKnight_Data.config.Temp_Target_Name ~= nil) then
			if GoHv5_DeathKnight_Data.config.KnownTypes == "NPC" then
				if UnitExists("target") and not UnitIsFriend("player", "target") then -- BEGIN NOT A FRIEND EXISTS CHECK

					GoHv5_DeathKnight_Data.config.Your_Target_Is_A = UnitCreatureType("target"); -- Really just want the type.
					local GoH_Temp_Target_Value = (UnitCreatureType("target").." ("..GoHv5_DeathKnight_Data.config.Temp_Target_Name..")");

						-- print("Current Target is: "..GoH_Temp_Target_Value);
						-- print("Your last kill was a: "..GoHv5_DeathKnight_Data.config.Your_Target_Was_A.." ("..GoHv5_DeathKnight_Data.config.Your_Target_Name_Was_A..")");

				else
					-- PROBABLY AN NPC GUARD
					-- print("Not a creature.");

					local name = UnitName("target");
					local guid = UnitGUID("target");
					 -- if guid ~= nil then
					 -- 	 ChatFrame1:AddMessage("NPC: "..name.." has the GUID: "..guid);
					 -- end

					-- GRAB THE GUID OF THE NPC GUARD
					GoHv5_DeathKnight_Data.config.Your_Target_Is_A = guid;
					GoHv5_DeathKnight_Data.config.KnownTypes = "not a creature";

				end
			end
			if GoHv5_DeathKnight_Data.config.KnownTypes == "player" then

				local name = UnitName("target");
				local guid = UnitGUID("target");
				 -- if guid ~= nil then
				 -- 	 ChatFrame1:AddMessage("PLAYER: "..name.." has the GUID: "..guid);
				 -- end

				-- GRAB THE GUID OF THE PLAYER
				GoHv5_DeathKnight_Data.config.Your_Target_Is_A = guid;

			end

			GoHv5_DeathKnight_Data.config.Temp_Target_Name = nil;
		end
		-- #######################################

end

function GoH.events.COMBAT_LOG_EVENT(arg1, GoH_Event, arg3, sourceGUID, GoH_Player, arg6, arg7, destGUID, GoH_Enemy)

	-- CHECK THE TIMER
	if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == nil then
		GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "YES";
	end

	-- ################################################################
	-- ################################################################


-- print(GoH_Event); print(GoH_Player); print(GoH_Enemy);

	if (GoHv5_DeathKnight_Data.config.KnownTypes == "player") or (GoHv5_DeathKnight_Data.config.KnownTypes == "not a creature") then

		if (GoH_Event == "PARTY_KILL") and (GoH_Player == GoH_DeathKnight.CharName) then

			-- SECONDARY TIMER
			if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

				GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows = (GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows + 1);

				-- RESET THE SECONDARY TIMER
				GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
				-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

			end

			if GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES" then
				-- print(GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows);

	  			if GoHv5_DeathKnight_Data.config.Use_Killing_Blows == "YES" then
					Play_Killing_Blows_Random_Sound();
				end
			end

			if GoHv5_DeathKnight_Data.config.Has_Taken_Damage == "NO" then
				-- print("Flawless Victory!");
				GoHv5_DeathKnight_Data.config.Flawless_Victory = "YES";
			else
				-- print("Ordinary Victory!");
				GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";
			end

			if (destGUID == GoHv5_DeathKnight_Data.config.Your_Target_Is_A) then

				GoHv5_DeathKnight_Data.config.Your_Target_Name_Was_A = GoH_Enemy -- NAME
				GoHv5_DeathKnight_Data.config.Your_Target_Was_A = GoHv5_DeathKnight_Data.config.Your_Target_Is_A -- GUID

				GoHv5_DeathKnight_Data.config.Last_Kill_By_You = "YES";
				GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level = GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level_TEMP;
			end

		end

	else

		if (GoH_Event == "PARTY_KILL") and (GoH_Player == GoH_DeathKnight.CharName) then

			-- SECONDARY TIMER
			if GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready == "YES" then

				GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows = (GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows + 1);

				-- RESET THE SECONDARY TIMER
				GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Secondary_Timer_Time = 0;
				-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

			end

			if GoHv5_DeathKnight_Data.config.Unit_In_Combat == "YES" then
				-- print(GoHv5_DeathKnight_Data.config.COUNTER_Killing_Blows);
	  			if GoHv5_DeathKnight_Data.config.Use_Killing_Blows == "YES" then
					Play_Killing_Blows_Random_Sound();
				end
			end

			if GoHv5_DeathKnight_Data.config.Has_Taken_Damage == "NO" then
				-- print("Flawless Victory!");
				GoHv5_DeathKnight_Data.config.Flawless_Victory = "YES";
			else
				-- print("Ordinary Victory!");
				GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";
			end

			GoHv5_DeathKnight_Data.config.Your_Target_Name_Was_A = GoH_Enemy -- NAME
			GoHv5_DeathKnight_Data.config.Your_Target_Was_A = GoHv5_DeathKnight_Data.config.Your_Target_Is_A -- TYPE

			GoHv5_DeathKnight_Data.config.Last_Kill_By_You = "YES";
			GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level = GoHv5_DeathKnight_Data.config.Last_Kill_By_You_Level_TEMP;

		end

	end
end

function GoH.events.DUEL_REQUESTED(arg1)

	-- arg1 = Challenger

		if GoHv5_DeathKnight_Data.config.Duel_Sound == "YES" then

			-- Update the variables to your current duel lost and won numbers.
			GoHv5_DeathKnight_Data.config.Duels_Won = GetStatistic(319);
			GoHv5_DeathKnight_Data.config.Duels_Lost = GetStatistic(320);

		end
		GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "NO";
		GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";
end

function GoH.events.DUEL_FINISHED()

	-- IF SOMETHING YOU KILLED IS TEN LEVELS BELOW YOU OR MORE, THEN YOU'RE A LOSER AND ARE INSULTED.
	local Temp_Level = (tonumber(GoH_DeathKnight.CharLevel) - 10);
	-- print(Temp_Level);
	-- (GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value <= Temp_Level)

		if GoHv5_DeathKnight_Data.config.Duel_Sound == "YES" then

			-- Update the variables to your current duel lost and won numbers.
			GoHv5_DeathKnight_Data.config.Duels_Won_Temp = GetStatistic(319);
			GoHv5_DeathKnight_Data.config.Duels_Lost_Temp = GetStatistic(320);

			if (Temp_Level ~= nil) and (GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value  ~= nil) then
				if (tonumber(GoHv5_DeathKnight_Data.config.Target_Level_Temp_Value) <= tonumber(Temp_Level)) then
					-- BELOW YOUR WORTH... (UNFAIR FIGHT)

						-- INSULTS (IF YOU HAVE THEM TURNED ON)
						if (GoHv5_DeathKnight_Data.config.Play_Insults == "YES") and (GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted == "NO") then

								if (GoHv5_DeathKnight_Data.config.Duels_Won + 1) == GoHv5_DeathKnight_Data.config.Duels_Won_Temp then
									-- YOU MUST HAVE WON THE DUEL, BUT YOU'RE A LOSER
									-- PLAY INSULT
									Play_Only_Insults();
								end
								if (GoHv5_DeathKnight_Data.config.Duels_Lost + 1) == GoHv5_DeathKnight_Data.config.Duels_Lost_Temp then
									-- YOU MUST HAVE LOST THE DUEL, AND STILL ARE A LOSER
									-- PLAY INSULT
									Play_Only_Insults();
								end

							-- CHANGE INSULT VARIABLE
							GoHv5_DeathKnight_Data.config.You_Have_Been_Insulted = "YES";
						end

				else
					-- OF THE SAME OR EQUAL STANDING (FAIR FIGHT)

						if (GoHv5_DeathKnight_Data.config.Duels_Won + 1) == GoHv5_DeathKnight_Data.config.Duels_Won_Temp then

							-- FLAWLESS VICTORY CHECK
							if GoHv5_DeathKnight_Data.config.Flawless_Victory == "NO" then
								-- NOT A FLAWLESS VICTORY BUT A FAIR FIGHT...

								-- YOU MUST HAVE WON THE DUEL - BUT NO FLAWLESS VICTORY
								Play_Duel_You_Win_Sound();

							else
								-- A FLAWLESS VICTORY IN A FAIR FIGHT.

								-- YOU MUST HAVE WON THE DUEL - AND GOT A FLAWLESS VICTORY!
								Play_Flawless_Victory();

								-- RESET THE VALUE
								GoHv5_DeathKnight_Data.config.Flawless_Victory = "NO";
							end

						end
						if (GoHv5_DeathKnight_Data.config.Duels_Lost + 1) == GoHv5_DeathKnight_Data.config.Duels_Lost_Temp then
							-- YOU MUST HAVE LOST THE DUEL - OBVIOUSLY NO FLAWLESS VICTORY HERE FOR YOU.
							-- AT LEAST IT WAS A FAIR FIGHT.
							Play_Duel_You_Lose_Sound();
						end
				end
			end
		end

end
